/* sevencolors_private.h
 *
 * Copyright (C) 2000 Stefano Bellotti
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#include <gnome.h>

/*
 * Returns the coordinates (x,y) of a corner.
 */
void game_table_corner_to_xy (GameTable *table, GameTableCorner corner, int *x, int *y);

/*
 * Reset all the flags.
 */
void game_table_clear (GameTable *table);

/*
 * Recursvive function that, starting from (x,y), change the color of all
 * reachable rhombs of color old_col to new_color.
 * For all neighbour rhombs of color old_color the recursive function
 * game_table_expand is called.
 * Returns the number of all acquired rhombs.
 */
int game_table_paint (GameTable *table, int x, int y, int old_col, int new_col);

/*
 * Like game_table_paint, but this function doesn't change the color, it sets
 * only the flag.
 */
int game_table_paint_fake (GameTable *table, int x, int y, int old_col, int new_col);

/*
 * Recursvive function that set the flag of all rhombs of color col reachable
 * from (x,y).
 * Returns the number of marked rhombs.
 */
int game_table_expand (GameTable *table, int x, int y, int col);

/*
 * Recursvive function that set the flag of all rhombs reachable from (x,y)
 * without passing on already market rhombs.
 */
void game_table_mark_reachable (GameTable *table, int x, int y);

/*
 * Change the color of all not marked rhombs.
 * Returns the number of painted rhombs.
 */
int game_table_paint_not_marked (GameTable *table, int col);

/*
 * Like game_table_paint_not_marked, but this function doesn't change the
 * color, it sets only the flag.
 */
int game_table_paint_not_marked_fake (GameTable *table);
